Index: .bzrignore
===================================================================
--- .bzrignore	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ .bzrignore	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -94,5 +94,4 @@
 ./uspace/drv/usbhid/usbhid
 ./uspace/drv/usbkbd/usbkbd
-./uspace/drv/usbmast/usbmast
 ./uspace/drv/usbmid/usbmid
 ./uspace/drv/usbmouse/usbmouse
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ boot/arch/amd64/Makefile.inc	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -50,6 +50,4 @@
 	usbhub \
 	usbkbd \
-	usbhid \
-	usbmast \
 	usbmid \
 	usbmouse \
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ kernel/Makefile	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -226,4 +226,5 @@
 	generic/src/proc/task.c \
 	generic/src/proc/the.c \
+	generic/src/proc/tasklet.c \
 	generic/src/syscall/syscall.c \
 	generic/src/syscall/copy.c \
@@ -381,4 +382,5 @@
 		generic/src/main/kinit.c \
 		generic/src/proc/the.c \
+		generic/src/proc/tasklet.c \
 		generic/src/mm/frame.c \
 		generic/src/mm/page.c \
Index: kernel/arch/mips32/include/atomic.h
===================================================================
--- kernel/arch/mips32/include/atomic.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ kernel/arch/mips32/include/atomic.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -91,5 +91,4 @@
 		"	sc %0, %1\n"
 		"	beqz %0, 1b\n"
-		"	nop\n"
 		"2:\n"
 		: "=&r" (tmp),
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ kernel/generic/include/ipc/ipc.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -115,10 +115,4 @@
  */
 #define IPC_FF_ROUTE_FROM_ME  (1 << 0)
-
-/* Data transfer flags. */
-#define IPC_XF_NONE		0
-
-/** Restrict the transfer size if necessary. */
-#define IPC_XF_RESTRICT		(1 << 0)
 
 /** Kernel IPC interfaces
Index: kernel/generic/include/proc/tasklet.h
===================================================================
--- kernel/generic/include/proc/tasklet.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
+++ kernel/generic/include/proc/tasklet.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -0,0 +1,73 @@
+/*
+ * Copyright (c) 2007 Jan Hudecek
+ * Copyright (c) 2008 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericproc
+ * @{
+ */
+/** @file tasklet.h
+ * @brief Tasklets declarations
+ */
+
+#ifndef KERN_TASKLET_H_
+#define KERN_TASKLET_H_
+
+#include <adt/list.h>
+
+/** Tasklet callback type */
+typedef void (* tasklet_callback_t)(void *arg);
+
+/** Tasklet state */
+typedef enum {
+	NotActive,
+	Scheduled,
+	InProgress,
+	Disabled
+} tasklet_state_t;
+
+/** Structure describing a tasklet */
+typedef struct tasklet_descriptor {
+	link_t link;
+	
+	/** Callback to call */
+	tasklet_callback_t callback;
+	
+	/** Argument passed to the callback */
+	void *arg;
+	
+	/** State of the tasklet */
+	tasklet_state_t state;
+} tasklet_descriptor_t;
+
+
+extern void tasklet_init(void);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ kernel/generic/src/ipc/sysipc.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -426,13 +426,7 @@
 	case IPC_M_DATA_READ: {
 		size_t size = IPC_GET_ARG2(call->data);
-		if (size <= 0)
+		if ((size <= 0 || (size > DATA_XFER_LIMIT)))
 			return ELIMIT;
-		if (size > DATA_XFER_LIMIT) {
-			int flags = IPC_GET_ARG3(call->data);
-			if (flags & IPC_XF_RESTRICT)
-				IPC_SET_ARG2(call->data, DATA_XFER_LIMIT);
-			else
-				return ELIMIT;
-		}
+		
 		break;
 	}
@@ -441,12 +435,6 @@
 		size_t size = IPC_GET_ARG2(call->data);
 		
-		if (size > DATA_XFER_LIMIT) {
-			int flags = IPC_GET_ARG3(call->data);
-			if (flags & IPC_XF_RESTRICT) {
-				size = DATA_XFER_LIMIT;
-				IPC_SET_ARG2(call->data, size);
-			} else
-				return ELIMIT;
-		}
+		if (size > DATA_XFER_LIMIT)
+			return ELIMIT;
 		
 		call->buffer = (uint8_t *) malloc(size, 0);
Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ kernel/generic/src/main/main.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -58,4 +58,5 @@
 #include <proc/thread.h>
 #include <proc/task.h>
+#include <proc/tasklet.h>
 #include <main/kinit.h>
 #include <main/version.h>
@@ -216,4 +217,5 @@
 	tlb_init();
 	ddi_init();
+	tasklet_init();
 	arch_post_mm_init();
 	arch_pre_smp_init();
Index: kernel/generic/src/proc/tasklet.c
===================================================================
--- kernel/generic/src/proc/tasklet.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
+++ kernel/generic/src/proc/tasklet.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2007 Jan Hudecek
+ * Copyright (c) 2008 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericproc
+ * @{
+ */
+/** @file tasklet.c
+ *  @brief Tasklet implementation
+ */
+
+#include <proc/tasklet.h>
+#include <synch/spinlock.h>
+#include <mm/slab.h>
+#include <config.h>
+
+/** Spinlock protecting list of tasklets */
+SPINLOCK_INITIALIZE(tasklet_lock);
+
+/** Array of tasklet lists for every CPU */
+tasklet_descriptor_t **tasklet_list;
+
+void tasklet_init(void)
+{
+	unsigned int i;
+	
+	tasklet_list = malloc(sizeof(tasklet_descriptor_t *) * config.cpu_count, 0);
+	if (!tasklet_list)
+		panic("Error initializing tasklets.");
+	
+	for (i = 0; i < config.cpu_count; i++)
+		tasklet_list[i] = NULL;
+	
+	spinlock_initialize(&tasklet_lock, "tasklet_lock");
+}
+
+
+/** @}
+ */
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/Makefile	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -123,7 +123,5 @@
 		drv/usbflbk \
 		drv/usbkbd \
-		drv/usbhid \
 		drv/usbhub \
-		drv/usbmast \
 		drv/usbmid \
 		drv/usbmouse \
@@ -145,7 +143,5 @@
 		drv/usbflbk \
 		drv/usbkbd \
-		drv/usbhid \
 		drv/usbhub \
-		drv/usbmast \
 		drv/usbmid \
 		drv/usbmouse \
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -195,5 +195,5 @@
 					wchar_t c = str_decode(buff, &offset, bytes);
 					if (c == 0) {
-						/* Reached end of string */
+						// reached end of string
 						break;
 					}
@@ -228,8 +228,6 @@
 	int rc;
 	
-	/*
-	 * reset global state
-	 * TODO: move to structure?
-	 */
+	// reset global state
+	// TODO: move to structure?
 	paging_enabled = false;
 	chars_remaining = 0;
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/app/trace/trace.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -53,5 +53,5 @@
 #include <libc.h>
 
-/* Temporary: service and method names */
+// Temporary: service and method names
 #include "proto.h"
 #include <ipc/services.h>
Index: uspace/app/usbinfo/dev.c
===================================================================
--- uspace/app/usbinfo/dev.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/app/usbinfo/dev.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -50,5 +50,4 @@
 
 	int rc;
-	bool transfer_started = false;
 
 	rc = usb_device_connection_initialize(&dev->wire, hc_handle, dev_addr);
@@ -77,12 +76,11 @@
 	}
 
-	rc = usb_pipe_start_long_transfer(&dev->ctrl_pipe);
+	rc = usb_pipe_start_session(&dev->ctrl_pipe);
 	if (rc != EOK) {
 		fprintf(stderr,
-		    NAME ": failed to start transfer on control pipe: %s.\n",
+		    NAME ": failed to start session on control pipe: %s.\n",
 		    str_error(rc));
 		goto leave;
 	}
-	transfer_started = true;
 
 	rc = usb_request_get_device_descriptor(&dev->ctrl_pipe,
@@ -109,6 +107,6 @@
 
 leave:
-	if (transfer_started) {
-		usb_pipe_end_long_transfer(&dev->ctrl_pipe);
+	if (usb_pipe_is_session_started(&dev->ctrl_pipe)) {
+		usb_pipe_end_session(&dev->ctrl_pipe);
 	}
 
@@ -120,5 +118,5 @@
 void destroy_device(usbinfo_device_t *dev)
 {
-	usb_pipe_end_long_transfer(&dev->ctrl_pipe);
+	usb_pipe_end_session(&dev->ctrl_pipe);
 	free(dev);
 }
Index: uspace/doc/doxygroups.h
===================================================================
--- uspace/doc/doxygroups.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/doc/doxygroups.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -251,12 +251,4 @@
 
 	/**
-	 * @defgroup drvusbmast USB mass storage driver
-	 * @ingroup usb
-	 * @brief USB driver for mass storage devices (bulk-only protocol).
-	 * This driver is a only a stub and is currently used only for
-	 * testing that bulk transfers work.
-	 */
-
-	/**
 	 * @defgroup drvusbuhci UHCI driver
 	 * @ingroup usb
@@ -277,10 +269,4 @@
 
 	/**
-	 * @defgroup drvusbohci OHCI driver
-	 * @ingroup usb
-	 * @brief Driver for OHCI host controller.
-	 */
-
-	/**
 	 * @defgroup drvusbehci EHCI driver
 	 * @ingroup usb
@@ -289,5 +275,5 @@
 
 	/**
-	 * @defgroup drvusbfallback USB fallback driver
+	 * @defgroup drvusbfallback USB fallback driver.
 	 * @ingroup usb
 	 * @brief Fallback driver for any USB device.
Index: uspace/drv/ehci-hcd/hc_iface.c
===================================================================
--- uspace/drv/ehci-hcd/hc_iface.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/ehci-hcd/hc_iface.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -123,5 +123,4 @@
  * @param[in] fun Device function the action was invoked on.
  * @param[in] address USB address of the device.
- * @param[in] speed Endpoint speed (invalid means to use device one).
  * @param[in] endpoint Endpoint number.
  * @param[in] transfer_type USB transfer type.
@@ -132,5 +131,5 @@
  */
 static int register_endpoint(ddf_fun_t *fun,
-    usb_address_t address, usb_speed_t speed, usb_endpoint_t endpoint,
+    usb_address_t address, usb_endpoint_t endpoint,
     usb_transfer_type_t transfer_type, usb_direction_t direction,
     size_t max_packet_size, unsigned int interval)
@@ -166,4 +165,5 @@
  * @param[in] fun Device function the action was invoked on.
  * @param[in] target Target pipe (address and endpoint number) specification.
+ * @param[in] max_packet_size Max packet size for the transfer.
  * @param[in] data Data to be sent (in USB endianess, allocated and deallocated
  *	by the caller).
@@ -174,5 +174,5 @@
  */
 static int interrupt_out(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
+    size_t max_packet_size, void *data, size_t size,
     usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
@@ -191,4 +191,5 @@
  * @param[in] fun Device function the action was invoked on.
  * @param[in] target Target pipe (address and endpoint number) specification.
+ * @param[in] max_packet_size Max packet size for the transfer.
  * @param[in] data Buffer where to store the data (in USB endianess,
  *	allocated and deallocated by the caller).
@@ -199,5 +200,5 @@
  */
 static int interrupt_in(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
+    size_t max_packet_size, void *data, size_t size,
     usbhc_iface_transfer_in_callback_t callback, void *arg)
 {
@@ -216,4 +217,5 @@
  * @param[in] fun Device function the action was invoked on.
  * @param[in] target Target pipe (address and endpoint number) specification.
+ * @param[in] max_packet_size Max packet size for the transfer.
  * @param[in] data Data to be sent (in USB endianess, allocated and deallocated
  *	by the caller).
@@ -224,5 +226,5 @@
  */
 static int bulk_out(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
+    size_t max_packet_size, void *data, size_t size,
     usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
@@ -241,4 +243,5 @@
  * @param[in] fun Device function the action was invoked on.
  * @param[in] target Target pipe (address and endpoint number) specification.
+ * @param[in] max_packet_size Max packet size for the transfer.
  * @param[in] data Buffer where to store the data (in USB endianess,
  *	allocated and deallocated by the caller).
@@ -249,5 +252,5 @@
  */
 static int bulk_in(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
+    size_t max_packet_size, void *data, size_t size,
     usbhc_iface_transfer_in_callback_t callback, void *arg)
 {
@@ -266,4 +269,5 @@
  * @param[in] fun Device function the action was invoked on.
  * @param[in] target Target pipe (address and endpoint number) specification.
+ * @param[in] max_packet_size Max packet size for the transfer.
  * @param[in] setup_packet Setup packet buffer (in USB endianess, allocated
  *	and deallocated by the caller).
@@ -277,4 +281,5 @@
  */
 static int control_write(ddf_fun_t *fun, usb_target_t target,
+    size_t max_packet_size,
     void *setup_packet, size_t setup_packet_size,
     void *data_buffer, size_t data_buffer_size,
@@ -295,4 +300,5 @@
  * @param[in] fun Device function the action was invoked on.
  * @param[in] target Target pipe (address and endpoint number) specification.
+ * @param[in] max_packet_size Max packet size for the transfer.
  * @param[in] setup_packet Setup packet buffer (in USB endianess, allocated
  *	and deallocated by the caller).
@@ -306,4 +312,5 @@
  */
 static int control_read(ddf_fun_t *fun, usb_target_t target,
+    size_t max_packet_size,
     void *setup_packet, size_t setup_packet_size,
     void *data_buffer, size_t data_buffer_size,
Index: uspace/drv/isa/isa.c
===================================================================
--- uspace/drv/isa/isa.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/isa/isa.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -83,5 +83,5 @@
 static bool isa_enable_fun_interrupt(ddf_fun_t *fnode)
 {
-	/* TODO */
+	// TODO
 
 	return false;
Index: uspace/drv/ohci/Makefile
===================================================================
--- uspace/drv/ohci/Makefile	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/ohci/Makefile	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -33,16 +33,11 @@
 
 SOURCES = \
+	iface.c \
 	batch.c \
-	endpoint_list.c \
+	main.c \
 	hc.c \
-	hcd_endpoint.c \
-	iface.c \
-	main.c \
 	ohci.c \
-	pci.c \
 	root_hub.c \
-	hw_struct/endpoint_descriptor.c \
-	hw_struct/transfer_descriptor.c
-
+	pci.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/drv/ohci/batch.c
===================================================================
--- uspace/drv/ohci/batch.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/ohci/batch.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -39,42 +39,25 @@
 
 #include "batch.h"
-#include "hcd_endpoint.h"
 #include "utils/malloc32.h"
-#include "hw_struct/endpoint_descriptor.h"
-#include "hw_struct/transfer_descriptor.h"
 
-typedef struct ohci_transfer_batch {
-	ed_t *ed;
-	td_t **tds;
-	size_t td_count;
-	size_t leave_td;
-	char *device_buffer;
-} ohci_transfer_batch_t;
+static void batch_call_in_and_dispose(usb_transfer_batch_t *instance);
+static void batch_call_out_and_dispose(usb_transfer_batch_t *instance);
 
-static void ohci_transfer_batch_dispose(void *ohci_batch)
-{
-	ohci_transfer_batch_t *instance = ohci_batch;
-	if (!instance)
-		return;
-	free32(instance->device_buffer);
-	unsigned i = 0;
-	if (instance->tds) {
-		for (; i< instance->td_count; ++i) {
-			if (i != instance->leave_td)
-				free32(instance->tds[i]);
-		}
-		free(instance->tds);
-	}
-	free(instance);
-}
-/*----------------------------------------------------------------------------*/
-static void batch_control(usb_transfer_batch_t *instance,
-    usb_direction_t data_dir, usb_direction_t status_dir);
-static void batch_data(usb_transfer_batch_t *instance);
-/*----------------------------------------------------------------------------*/
-usb_transfer_batch_t * batch_get(ddf_fun_t *fun, endpoint_t *ep,
-    char *buffer, size_t buffer_size, char* setup_buffer, size_t setup_size,
+#define DEFAULT_ERROR_COUNT 3
+usb_transfer_batch_t * batch_get(
+    ddf_fun_t *fun,
+		usb_target_t target,
+    usb_transfer_type_t transfer_type,
+		size_t max_packet_size,
+    usb_speed_t speed,
+		char *buffer,
+		size_t buffer_size,
+		char *setup_buffer,
+		size_t setup_size,
     usbhc_iface_transfer_in_callback_t func_in,
-    usbhc_iface_transfer_out_callback_t func_out, void *arg)
+    usbhc_iface_transfer_out_callback_t func_out,
+		void *arg,
+		usb_device_keeper_t *manager
+		)
 {
 #define CHECK_NULL_DISPOSE_RETURN(ptr, message...) \
@@ -82,5 +65,5 @@
                 usb_log_error(message); \
                 if (instance) { \
-                        usb_transfer_batch_dispose(instance); \
+                        batch_dispose(instance); \
                 } \
                 return NULL; \
@@ -90,105 +73,31 @@
 	CHECK_NULL_DISPOSE_RETURN(instance,
 	    "Failed to allocate batch instance.\n");
-	usb_transfer_batch_init(instance, ep, buffer, NULL, buffer_size,
-	    NULL, setup_size, func_in, func_out, arg, fun, NULL,
-	    ohci_transfer_batch_dispose);
+	usb_transfer_batch_init(instance, target, transfer_type, speed,
+	    max_packet_size, buffer, NULL, buffer_size, NULL, setup_size,
+	    func_in, func_out, arg, fun, NULL, NULL);
 
-	hcd_endpoint_t *hcd_ep = hcd_endpoint_get(ep);
-	assert(hcd_ep);
+        if (buffer_size > 0) {
+                instance->transport_buffer = malloc32(buffer_size);
+                CHECK_NULL_DISPOSE_RETURN(instance->transport_buffer,
+                    "Failed to allocate device accessible buffer.\n");
+        }
 
-	ohci_transfer_batch_t *data = calloc(sizeof(ohci_transfer_batch_t), 1);
-	CHECK_NULL_DISPOSE_RETURN(data, "Failed to allocate batch data.\n");
-	instance->private_data = data;
-
-	data->td_count =
-	    ((buffer_size + OHCI_TD_MAX_TRANSFER - 1) / OHCI_TD_MAX_TRANSFER);
-	if (ep->transfer_type == USB_TRANSFER_CONTROL) {
-		data->td_count += 2;
-	}
-
-	/* we need one extra place for td that is currently assigned to hcd_ep*/
-	data->tds = calloc(sizeof(td_t*), data->td_count + 1);
-	CHECK_NULL_DISPOSE_RETURN(data->tds,
-	    "Failed to allocate transfer descriptors.\n");
-
-	data->tds[0] = hcd_ep->td;
-	data->leave_td = 0;
-	unsigned i = 1;
-	for (; i <= data->td_count; ++i) {
-		data->tds[i] = malloc32(sizeof(td_t));
-		CHECK_NULL_DISPOSE_RETURN(data->tds[i],
-		    "Failed to allocate TD %d.\n", i );
-	}
-
-	data->ed = hcd_ep->ed;
-
-        if (setup_size + buffer_size > 0) {
-		data->device_buffer = malloc32(setup_size + buffer_size);
-                CHECK_NULL_DISPOSE_RETURN(data->device_buffer,
-                    "Failed to allocate device accessible buffer.\n");
-		instance->setup_buffer = data->device_buffer;
-		instance->data_buffer = data->device_buffer + setup_size;
+        if (setup_size > 0) {
+                instance->setup_buffer = malloc32(setup_size);
+                CHECK_NULL_DISPOSE_RETURN(instance->setup_buffer,
+                    "Failed to allocate device accessible setup buffer.\n");
                 memcpy(instance->setup_buffer, setup_buffer, setup_size);
         }
+
 
 	return instance;
 }
 /*----------------------------------------------------------------------------*/
-bool batch_is_complete(usb_transfer_batch_t *instance)
+void batch_dispose(usb_transfer_batch_t *instance)
 {
 	assert(instance);
-	ohci_transfer_batch_t *data = instance->private_data;
-	assert(data);
-	size_t tds = data->td_count;
-	usb_log_debug("Batch(%p) checking %d td(s) for completion.\n",
-	    instance, tds);
-	usb_log_debug("ED: %x:%x:%x:%x.\n",
-	    data->ed->status, data->ed->td_head, data->ed->td_tail,
-	    data->ed->next);
-	size_t i = 0;
-	instance->transfered_size = instance->buffer_size;
-	for (; i < tds; ++i) {
-		assert(data->tds[i] != NULL);
-		usb_log_debug("TD %d: %x:%x:%x:%x.\n", i,
-		    data->tds[i]->status, data->tds[i]->cbp, data->tds[i]->next,
-		    data->tds[i]->be);
-		if (!td_is_finished(data->tds[i])) {
-			return false;
-		}
-		instance->error = td_error(data->tds[i]);
-		if (instance->error != EOK) {
-			usb_log_debug("Batch(%p) found error TD(%d):%x.\n",
-			    instance, i, data->tds[i]->status);
-			/* Make sure TD queue is empty (one TD),
-			 * ED should be marked as halted */
-			data->ed->td_tail =
-			    (data->ed->td_head & ED_TDTAIL_PTR_MASK);
-			++i;
-			break;
-		}
-	}
-	data->leave_td = i;
-	assert(data->leave_td <= data->td_count);
-	hcd_endpoint_t *hcd_ep = hcd_endpoint_get(instance->ep);
-	assert(hcd_ep);
-	hcd_ep->td = data->tds[i];
-	if (i > 0)
-		instance->transfered_size -= td_remain_size(data->tds[i - 1]);
-
-	/* Clear possible ED HALT */
-	data->ed->td_head &= ~ED_TDHEAD_HALTED_FLAG;
-	uint32_t pa = addr_to_phys(hcd_ep->td);
-	assert(pa == (data->ed->td_head & ED_TDHEAD_PTR_MASK));
-	assert(pa == (data->ed->td_tail & ED_TDTAIL_PTR_MASK));
-
-	return true;
-}
-/*----------------------------------------------------------------------------*/
-void batch_commit(usb_transfer_batch_t *instance)
-{
-	assert(instance);
-	ohci_transfer_batch_t *data = instance->private_data;
-	assert(data);
-	ed_set_end_td(data->ed, data->tds[data->td_count]);
+	free32(instance->transport_buffer);
+	free32(instance->setup_buffer);
+	free(instance);
 }
 /*----------------------------------------------------------------------------*/
@@ -197,7 +106,8 @@
 	assert(instance);
 	/* We are data out, we are supposed to provide data */
-	memcpy(instance->data_buffer, instance->buffer, instance->buffer_size);
-	instance->next_step = usb_transfer_batch_call_out_and_dispose;
-	batch_control(instance, USB_DIRECTION_OUT, USB_DIRECTION_IN);
+	memcpy(instance->transport_buffer, instance->buffer,
+	    instance->buffer_size);
+	instance->next_step = batch_call_out_and_dispose;
+	/* TODO: implement */
 	usb_log_debug("Batch(%p) CONTROL WRITE initialized.\n", instance);
 }
@@ -206,6 +116,6 @@
 {
 	assert(instance);
-	instance->next_step = usb_transfer_batch_call_in_and_dispose;
-	batch_control(instance, USB_DIRECTION_IN, USB_DIRECTION_OUT);
+	instance->next_step = batch_call_in_and_dispose;
+	/* TODO: implement */
 	usb_log_debug("Batch(%p) CONTROL READ initialized.\n", instance);
 }
@@ -214,6 +124,7 @@
 {
 	assert(instance);
-	instance->next_step = usb_transfer_batch_call_in_and_dispose;
-	batch_data(instance);
+	instance->direction = USB_DIRECTION_IN;
+	instance->next_step = batch_call_in_and_dispose;
+	/* TODO: implement */
 	usb_log_debug("Batch(%p) INTERRUPT IN initialized.\n", instance);
 }
@@ -222,8 +133,10 @@
 {
 	assert(instance);
+	instance->direction = USB_DIRECTION_OUT;
 	/* We are data out, we are supposed to provide data */
-	memcpy(instance->data_buffer, instance->buffer, instance->buffer_size);
-	instance->next_step = usb_transfer_batch_call_out_and_dispose;
-	batch_data(instance);
+	memcpy(instance->transport_buffer, instance->buffer,
+	    instance->buffer_size);
+	instance->next_step = batch_call_out_and_dispose;
+	/* TODO: implement */
 	usb_log_debug("Batch(%p) INTERRUPT OUT initialized.\n", instance);
 }
@@ -232,6 +145,7 @@
 {
 	assert(instance);
-	instance->next_step = usb_transfer_batch_call_in_and_dispose;
-	batch_data(instance);
+	instance->direction = USB_DIRECTION_IN;
+	instance->next_step = batch_call_in_and_dispose;
+	/* TODO: implement */
 	usb_log_debug("Batch(%p) BULK IN initialized.\n", instance);
 }
@@ -240,95 +154,30 @@
 {
 	assert(instance);
-	/* We are data out, we are supposed to provide data */
-	memcpy(instance->data_buffer, instance->buffer, instance->buffer_size);
-	instance->next_step = usb_transfer_batch_call_out_and_dispose;
-	batch_data(instance);
-	usb_log_debug("Batch(%p) BULK OUT initialized.\n", instance);
+	instance->direction = USB_DIRECTION_IN;
+	instance->next_step = batch_call_in_and_dispose;
+	/* TODO: implement */
+	usb_log_debug("Batch(%p) BULK IN initialized.\n", instance);
 }
 /*----------------------------------------------------------------------------*/
-ed_t * batch_ed(usb_transfer_batch_t *instance)
+/** Helper function calls callback and correctly disposes of batch structure.
+ *
+ * @param[in] instance Batch structure to use.
+ */
+void batch_call_in_and_dispose(usb_transfer_batch_t *instance)
 {
 	assert(instance);
-	ohci_transfer_batch_t *data = instance->private_data;
-	assert(data);
-	return data->ed;
+	usb_transfer_batch_call_in(instance);
+	batch_dispose(instance);
 }
 /*----------------------------------------------------------------------------*/
-void batch_control(usb_transfer_batch_t *instance,
-    usb_direction_t data_dir, usb_direction_t status_dir)
+/** Helper function calls callback and correctly disposes of batch structure.
+ *
+ * @param[in] instance Batch structure to use.
+ */
+void batch_call_out_and_dispose(usb_transfer_batch_t *instance)
 {
 	assert(instance);
-	ohci_transfer_batch_t *data = instance->private_data;
-	assert(data);
-	usb_log_debug("Using ED(%p): %x:%x:%x:%x.\n", data->ed,
-	    data->ed->status, data->ed->td_tail, data->ed->td_head,
-	    data->ed->next);
-	int toggle = 0;
-	/* setup stage */
-	td_init(data->tds[0], USB_DIRECTION_BOTH, instance->setup_buffer,
-		instance->setup_size, toggle);
-	td_set_next(data->tds[0], data->tds[1]);
-	usb_log_debug("Created SETUP TD: %x:%x:%x:%x.\n", data->tds[0]->status,
-	    data->tds[0]->cbp, data->tds[0]->next, data->tds[0]->be);
-
-	/* data stage */
-	size_t td_current = 1;
-	size_t remain_size = instance->buffer_size;
-	char *buffer = instance->data_buffer;
-	while (remain_size > 0) {
-		size_t transfer_size = remain_size > OHCI_TD_MAX_TRANSFER ?
-		    OHCI_TD_MAX_TRANSFER : remain_size;
-		toggle = 1 - toggle;
-
-		td_init(data->tds[td_current], data_dir, buffer,
-		    transfer_size, toggle);
-		td_set_next(data->tds[td_current], data->tds[td_current + 1]);
-		usb_log_debug("Created DATA TD: %x:%x:%x:%x.\n",
-		    data->tds[td_current]->status, data->tds[td_current]->cbp,
-		    data->tds[td_current]->next, data->tds[td_current]->be);
-
-		buffer += transfer_size;
-		remain_size -= transfer_size;
-		assert(td_current < data->td_count - 1);
-		++td_current;
-	}
-
-	/* status stage */
-	assert(td_current == data->td_count - 1);
-	td_init(data->tds[td_current], status_dir, NULL, 0, 1);
-	td_set_next(data->tds[td_current], data->tds[td_current + 1]);
-	usb_log_debug("Created STATUS TD: %x:%x:%x:%x.\n",
-	    data->tds[td_current]->status, data->tds[td_current]->cbp,
-	    data->tds[td_current]->next, data->tds[td_current]->be);
-}
-/*----------------------------------------------------------------------------*/
-void batch_data(usb_transfer_batch_t *instance)
-{
-	assert(instance);
-	ohci_transfer_batch_t *data = instance->private_data;
-	assert(data);
-	usb_log_debug("Using ED(%p): %x:%x:%x:%x.\n", data->ed,
-	    data->ed->status, data->ed->td_tail, data->ed->td_head,
-	    data->ed->next);
-
-	size_t td_current = 0;
-	size_t remain_size = instance->buffer_size;
-	char *buffer = instance->data_buffer;
-	while (remain_size > 0) {
-		size_t transfer_size = remain_size > OHCI_TD_MAX_TRANSFER ?
-		    OHCI_TD_MAX_TRANSFER : remain_size;
-
-		td_init(data->tds[td_current], instance->ep->direction,
-		    buffer, transfer_size, -1);
-		td_set_next(data->tds[td_current], data->tds[td_current + 1]);
-		usb_log_debug("Created DATA TD: %x:%x:%x:%x.\n",
-		    data->tds[td_current]->status, data->tds[td_current]->cbp,
-		    data->tds[td_current]->next, data->tds[td_current]->be);
-
-		buffer += transfer_size;
-		remain_size -= transfer_size;
-		assert(td_current < data->td_count);
-		++td_current;
-	}
+	usb_transfer_batch_call_out(instance);
+	batch_dispose(instance);
 }
 /**
